"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generator = exports.generatedFileName = void 0;
const od_1 = __importDefault(require("od"));
const change_case_1 = require("change-case");
const licenses_1 = require("./licenses");
function generatedFileName(templateFileName) {
    return templateFileName
        .replace(/^.*\//, "")
        .replace(/_dot_/g, ".")
        .replace(/dot_/g, ".");
}
exports.generatedFileName = generatedFileName;
function generator(generator, userInput) {
    return function generate(template, destination) {
        if (destination === undefined) {
            destination = generatedFileName(template);
        }
        generator.fs.copyTpl(generator.templatePath(template), generator.destinationPath(destination), Object.assign(Object.assign(Object.assign({}, userInput), licenses_1.licenseBadgeMarkdown(userInput.license)), { dateYear: od_1.default.get("year", new Date()), exportStatement: generator.options.default ? "export default" : "export", importStatement: generator.options.default
                ? change_case_1.camelCase(userInput.packageNameKebabCase)
                : ["{", change_case_1.camelCase(userInput.packageNameKebabCase), "}"].join(" ") }));
    };
}
exports.generator = generator;
