"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const os = __importStar(require("os"));
const path = __importStar(require("path"));
const t = __importStar(require("io-ts"));
const yeoman_generator_1 = __importDefault(require("yeoman-generator"));
const io_ts_docopt_1 = require("io-ts-docopt");
const change_case_1 = require("change-case");
const generate_1 = require("./generate");
const input_1 = require("./input");
const licenses_1 = require("./licenses");
const docstring = `
Usage:
    yo typescript-package [--lerna] [--bin]
`;
const CommandLineOptions = io_ts_docopt_1.withEncode(t.type({
    "--lerna": t.boolean,
    "--bin": t.boolean,
}), (a) => ({
    lerna: a["--lerna"],
    bin: a["--bin"],
}));
let userInput;
let generateTemplate;
module.exports = class extends yeoman_generator_1.default {
    constructor(args, opts) {
        super(args, opts);
        this.option("lerna", {
            description: "The generated package will be incorporated into a lerna monoepo",
            default: false,
            type: Boolean,
        });
        this.option("bin", {
            description: "Provide a bin target to index.ts",
            default: false,
            type: Boolean,
        });
    }
    initializing() {
        // Used for side-effects, throws if unsatisfied.
        // Yeoman provides access to these options
        io_ts_docopt_1.decodeDocopt(CommandLineOptions, docstring);
    }
    prompting() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.prompt([
                {
                    type: "input",
                    name: "scope",
                    message: "npm scope",
                    default: "",
                    store: true,
                },
                {
                    type: "input",
                    name: "packageNameKebabCase",
                    message: "Your package name (no word-breaks)",
                    default: change_case_1.paramCase(path.basename(this.appname)), // defaults to current folder name
                },
                {
                    type: "input",
                    name: "tagline",
                    message: "Your project tagline",
                    default: "Brief and fresh sentence fragment",
                },
                {
                    type: "input",
                    name: "keywords",
                    message: "npm keywords",
                    default: "",
                },
                {
                    type: "list",
                    name: "license",
                    message: "License",
                    choices: licenses_1.supportedLicenses,
                },
                {
                    type: "input",
                    name: "copyrightHolder",
                    message: "Name of copyright holder",
                    default: input_1.gitFullName(input_1.globalGitConfig()).orDefault(""),
                    store: true,
                },
                {
                    type: "input",
                    name: "gitRepository",
                    message: "Your hosted git repository (https)",
                    // eslint-disable-next-line @typescript-eslint/no-explicit-any
                    default: input_1.gitRemote(input_1.localGitConfig(this.contextRoot)).orDefault([
                        "https://github.com",
                        input_1.gitUsername(input_1.globalGitConfig()).orDefault(os.userInfo().username),
                        this.appname.replace(/ /g, "-"),
                    ].join("/")),
                },
                {
                    type: "input",
                    name: "version",
                    message: "Initial project version",
                    default: "0.0.1",
                },
                {
                    type: "input",
                    name: "author",
                    message: "Your name",
                    default: input_1.gitFullName(input_1.globalGitConfig()).orDefault(""),
                },
                {
                    type: "input",
                    name: "email",
                    message: "Your email address",
                    default: input_1.gitEmail(input_1.globalGitConfig()).orDefault(""),
                },
            ]).then((answers) => {
                userInput = Object.assign(Object.assign({}, answers), { bin: this.options.bin, gitRepository: input_1.gitRepositoryWithoutSuffix(answers.gitRepository), keywords: answers.keywords.split(/\s+/).filter((str) => str.length > 0), scopedPackageName: input_1.scopedPackageName(answers.scope, answers.packageNameKebabCase), packageNameCamelCase: change_case_1.camelCase(answers.packageNameKebabCase), gitHost: input_1.gitHost(answers.gitRepository).orDefault("TODO: could not determine git host"), gitGroup: input_1.gitGroup(answers.gitRepository).orDefault("TODO: could not determine git group"), gitUsername: input_1.gitUsername(input_1.globalGitConfig()).orDefault(os.userInfo().username) });
                generateTemplate = generate_1.generator(this, userInput);
            });
        });
    }
    generateSimpleTemplates() {
        generateTemplate("package_dot_json");
        generateTemplate("README.md");
        generateTemplate("src/index.ts", "src/index.ts");
        generateTemplate("test/unit/test.ts", `test/unit/test-${userInput.packageNameKebabCase}.ts`);
        generateTemplate("test/system/test.ts", `test/system/test-${userInput.packageNameKebabCase}.ts`);
        generateTemplate("test/property/test.ts", `test/property/test-${userInput.packageNameKebabCase}.ts`);
        if (this.options.lerna) {
            generateTemplate("lerna/tsconfig.json");
        }
        else {
            generateTemplate("tsconfig.json");
            generateTemplate("dot_eslintrc.json");
            generateTemplate("dot_gitignore");
            generateTemplate("dot_lintstagedrc.json");
            generateTemplate("dot_nycrc.json");
            generateTemplate("dot_prettierrc.json");
            generateTemplate("dot_editorconfig");
        }
        generateTemplate("licenses/" + userInput.license.toLowerCase(), "LICENSE");
    }
    generateGitForgeCiFile() {
        if (this.options.lerna) {
            return;
        }
        switch (userInput.gitHost) {
            case "github.com":
                generateTemplate("dot_github/workflows/ci.yml", ".github/workflows/ci.yml");
                break;
            case "gitlab.com":
                generateTemplate("dot_gitlab-ci.yml");
                break;
        }
    }
    addPackageJsonKeywords() {
        if (userInput.keywords.length > 0) {
            this.fs.extendJSON(this.destinationPath("package.json"), {
                keywords: userInput.keywords,
            });
        }
    }
    addPackageJsonPublishConfig() {
        switch (userInput.license) {
            case licenses_1.proprietaryLicense:
                this.fs.extendJSON(this.destinationPath("package.json"), {
                    private: true,
                });
                break;
            default:
                if (userInput.scope.length > 0) {
                    this.fs.extendJSON(this.destinationPath("package.json"), {
                        publishConfig: {
                            access: "public",
                        },
                    });
                }
                break;
        }
    }
    addBinTarget() {
        if (this.options.bin) {
            this.fs.extendJSON(this.destinationPath("package.json"), {
                bin: {
                    [userInput.packageNameKebabCase]: "./dist/src/index.js",
                },
            });
        }
    }
    customizeLernaPackageJson() {
        if (!this.options.lerna) {
            return;
        }
        const packagejson = this.destinationPath("package.json");
        this.fs.extendJSON(packagejson, {
            scripts: {
                prepublishOnly: "npm run build",
                build: "tsc --build --incremental --verbose .",
            },
        });
    }
    install() {
        if (!this.options.lerna) {
            this.npmInstall();
        }
    }
    end() {
        console.log(`
Check for outdated dependencies by running:

    \`npx ncu\`

Please commit before making changes by running:

    \`git add . && git commit --no-verify -m 'initial commit'\`
`);
    }
};
//  LocalWords:  monoepo copyrightHolder gitRepository gitUsername
//  LocalWords:  globalGitConfig packageNameKebabCase eslintrc
//  LocalWords:  prettierrc ncu npx lintstagedrc
